<template>
  <v-layout
    wrap
    row>
    <v-flex 
      v-if="$route.params.id === 'new'"
      xs12>
      <v-combobox
        v-model="new_customer"
        :items="customers.map(c => c.name)"
        label="Cliente" 
        @keyup.enter="checkCustomer()"
      />
      <v-select
        v-model="new_source"
        :items="destinations.map(d => d.name)"
        label="Local de Saída" />
      <v-btn 
        v-if="$route.params.id === 'new'"
        @click="create()">
        Criar
      </v-btn>
    </v-flex>
    <v-flex
      v-if="$route.params.id !== 'new'"
      xs12>
      <p>
        <span 
          class="title">
          Cliente: {{ customers.filter(c => c._id === remessa.customer)[0].name }}
        </span>
      </p>
      <p>
        <span 
          class="title">
          Origem: {{ destinations.filter(l => l._id === remessa.from)[0].name }}
        </span>  
      </p>
    </v-flex>
    <v-flex 
      v-if="$route.params.id != 'new'"
      xs12>
      <v-card>
        <v-toolbar dense>
          Pacotes
        </v-toolbar>
        <v-card-text>
          <v-layout>
            <v-flex 
              pa-1
              xs5>
              <v-select
                v-model="new_package_dest"
                :items="destinations.filter(d => d._id !== remessa.from).map(d => d.name)"
                label="Destino"/>
            </v-flex>
            <v-flex 
              pa-1
              xs4>
              <v-text-field
                v-model="new_package_weight"
                label="Peso" />
            </v-flex>
            <v-flex 
              pa-1
              xs1>
              <v-btn @click="addPackage()"><v-icon>add</v-icon></v-btn>
            </v-flex>
          </v-layout>
          <v-layout
            row
            wrap>
            <v-flex 
              v-for="(p, idxp) in remessa.packages"
              :key="idxp"
              xs3
              pa-1
            >
              <v-card light>
                <v-toolbar 
                  dense 
                  color="blue darken-4 white--text">
                  <span class="title">{{ destinations.filter(d => d._id === p.destination)[0].name }}</span>
                </v-toolbar>
                <v-card-text color="">
                  <span class="title">{{ p.weight }}g</span>
                </v-card-text>
              </v-card>
            </v-flex>
          </v-layout>
        </v-card-text>
      </v-card>
    </v-flex>

  </v-layout>
</template>

<script>
export default {
  asyncData ({app, route}) {
    var recordPromise = null;
    if(route.params.id === 'new') {
      recordPromise = Promise.resolve({ data: { packages: [] } } )
    } else {
      recordPromise = app.$axios.get('/orders/' + route.params.id)
    }

    return Promise.all([
      app.$axios.get('/customers'),
      app.$axios.get('/locations'),
      recordPromise
    ])
    .then(result => {
      return {
        customers: result[0].data,
        destinations: result[1].data,
        remessa: result[2].data
      }
    })
    .catch(error => {
      console.error("** Erro ao ler os dados:", error)
      return {

      }
    })
  },

  data () {
    return {
      new_package_dest: '',
      new_package_weight: 0,
      new_customer: '',
      new_source: ''
    }
  },

  methods: {
    checkCustomer () {
      var found = this.customers.filter(c => c.name === this.new_customer).length
      if(found == 0) {
        this.$axios.post('/customers', { name: this.new_customer })
          .then(response => {
            this.customers.push(response.data)
          })
          .catch(error => console.log("Erro ao criar cliente:", error))
      }
    },

    create () {
      // Atualiza o cliente para ser o codigo
      this.remessa.customer = this.customers.filter(c => c.name === this.new_customer)[0]._id
      this.remessa.from = this.destinations.filter(d => d.name === this.new_source)[0]._id

      this.$axios.post('/orders', this.remessa)
        .then(response => {
          this.$router.push('' + response.data._id)
        })
        .catch(error => console.log("Erro ao criar remessa:", error))
    },
    addPackage () {
      this.remessa.packages.push({
        destination: this.destinations.filter(d => d.name === this.new_package_dest)[0]._id,
        weight: parseInt(this.new_package_weight)
      })

      this.$axios.put('/orders/' + this.remessa._id, this.remessa)
        .then(response => {
          console.log('pacote atualizado:', response.data)
        })
        .catch(error => console.log("Erro ao criar remessa:", error))

      this.new_package_dest = ''
      this.new_package_weight = 0
    }
  }
}
</script>

<style>

</style>
